#include "stdafx.h"
#include "clf_util.h"

void print( TCHAR* strMsg, ... )
{
#if defined(DEBUG) | defined(_DEBUG) | defined(_TEST)
	TCHAR strBuffer[512];

	va_list args;
	va_start(args, strMsg);
	_vsntprintf( strBuffer, 512, strMsg, args );
	va_end(args);

#if defined(_WIN32) | defined (WIN32)
	OutputDebugString( strBuffer );
#else
	printf("%s", strBuffer); 
#endif
#else
#if defined(_WIN32) | defined (WIN32)
	UNREFERENCED_PARAMETER(strMsg);
#endif
#endif
}

unsigned long getFileLength(std::ifstream& file)
{
    if(!file.good()) return 0;
    
    std::streamoff pos = file.tellg();
    file.seekg(0,std::ios::end);
    std::streamoff len = file.tellg();
    file.seekg(pos);//std::ios::beg);
    
    return (unsigned long)len;
}

GLchar* load_file_buffer(const char* filename)
{
	std::ifstream file;
	file.open(filename, std::ios::in);
	if(!file) return NULL;

	unsigned long len = getFileLength(file);

	if (len==0) return NULL;

	GLchar* fbuf = (GLchar*) new char[len+1];
	if (fbuf == 0) return NULL;   // can't reserve memory

	fbuf[len] = 0;  // len isn't always strlen cause some characters are stripped in ascii read...
	// it is important to 0-terminate the real length later, len is just max possible value...
	unsigned int i=0;
	while (file.good())
	{
		fbuf[i] = file.get();       // get character from file.
		if (!file.eof())
			i++;
	}

	fbuf[i] = 0;  // 0 terminate it.

	file.close();

	return fbuf;
}
